#!/usr/bin/perl
# Copyright 2000, AskAround, Inc.
# http://askaround.com
# Author: Brad Doctor (bdoctor@askaround.com)
# License: GPL

my $config_file = "/etc/httpd/conf/wireless.cfg";


my $DEBUG = 0;
# read configuration

 open (CONFIG, "< $config_file") || die "Can't open config: $!\n";
   while (<CONFIG>) {
       chomp;
       s/#.*//;
       s/^\s+//;
       s/\s+$//;
       next unless length;
       my ( $var, $value ) = split(/\s*=\s*/, $_, 2);
        if ( $value =~ /\,/ ) {
           push(@{$var}, (split(/\,/, $value)));
       }
       $config{$var} = $value;
   } # while config

  close CONFIG;


($command,$option) = split(/\\\\\\\\/, $ARGV[0]);
$command = shift if ( $command eq "" );


print "Content-type: text/vnd.wap.wml\n\n";

$header = "
<?xml version=\"1.0\"?>
<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\"
                        \"http://www.wapforum.org/DTD/wml_1.1.xml\">
";

  if ( $command eq "netstat" ) {
      hdml_netstat();
  } elsif ( $command eq "hosts" ) {
      hdml_hosts();
  } elsif ( $command eq "portscan" ) {
      port_scan($option);
  } elsif ( $command eq "traceroute" ) {
      traceroute($option);
  }

sub hdml_netstat {

 print $header; 
 print "<wml>";
 print "
   <card id=\"netstat\" title=\"NetStat\">
    <p>
     <select>\n";

$count = 0;

open(INPUT, "< $config{status_log}") 
     || die "Can't open $config{status_log}: $!\n";

  while (<INPUT>) {
     chomp;
     if (/DOWN$/) {
        push(@down, $_);
     }
     if (/UP/) {
        push(@up, $_);
     }
 }

    foreach $i ( @down ) {
        $count++;
        $i =~ (s/\s+//g);
         next if ( $down{$i} );
        ($null,$down{$i}) = (split(/\;/, $i)); 
        print "
       <option onpick=\"$config{ping_cgi}?$down{$i}\">Problem: $down{$i}</option>";
    }

    foreach $i ( @up ) {
        $count++;
        $i =~ (s/\s+//g);
         next if ( $okay{$i} );
        ($null,$okay{$i}) = (split(/\;/, $i)); 
        print "
        <option onpick=\"$config{ping_cgi}?$okay{$i}\">Okay: $okay{$i}</option>";
    }
 
close INPUT;

  print "
<option onpick=\"../../nagios/$config{wml_root}\">BACK</option>
    </select>
  </p>
   </card>
  </wml>
  ";

} # sub hdml-netstat


sub hdml_hosts {

 print $header;
 print "
   <wml>
     <card title=\"Host Status\">
      <p>
       Host Status
       <select>\n";

$count = 0;

open(INPUT, "< $config{nagios_config}") 
     || die "Can't open $config{nagios_config}: $!\n";

  while (<INPUT>) {
     chomp;
     if (/^host\[/) {
        ($label,$data) = split(/\=/, $_);
        ($host,$data) =  (split(/\;/, $data));
          next if ( $hosts{$host} );
         $hosts{$host} .= $data;
       next;
    } # if host
 } # while

 while ( ($key,$val) = (each(%hosts)) ) {
        $key,$val =~ (s/<(?:[^>'"]*|(['"]).*?\1)*>//gs);
        print "
       <option onpick=\"$config{ping_cgi}?$val\">$key</option>";
    }
close INPUT;

  print "
<option onpick=\"../../nagios/$config{WMl_root}\">BACK</option>
    </select>
   </p>
   </card>
  </wml>
   ";
} # sub hdml-hosts

sub port_scan {

print $header;

print "<wml>\n";

use IO::Handle;
autoflush STDOUT 1;
use IO::Socket;

my $remote = shift; 
my $portnum = shift || 100;

$remote =~ (s/<(?:[^>'"]*|(['"]).*?\1)*>//gs);
$remote =~ ( s/\s*//g);


print "<card title=\"Scan: $remote\" id=\"portscan\">\n";
print "<p mode=\"wrap\">\n";
print "Scanning: $remote\n";
print "
  <select>
   <option onpick=\"#summary\">Scan Summary</option>
   <option onpick=\"#detail\">Scan Detail</option>
   <option onpick=\"../../nagios/$config{wml_root}\">BACK</option>
  </select>
 </p>
</card>";

print "
<card id =\"detail\">
<p>Scan Detail</p> <p>\n";

use vars qw ($port_count $i @socks $num );
   while ( $port_count <= $portnum ) {
           $port_count++;

      my $sock = IO::Socket::INET->new(PeerAddr	=>	$remote,
                                   PeerPort	=>	$port_count,
                                   Proto	=>	'tcp');
         if ( $sock ) {
               push(@socks, $port_count);
                print "Connect on: $port_count\n";     
         }
      undef $sock;
      next;
} # while

print "
<select>
          <option onpick=\"#portscan\">BACK</option>
         </select>
";

print "</p></card>";

     if ( $#socks <= 0 ) {
print "
     <card id =\"summary\">
        <p mode=\"wrap\">
          No open ports, or host unknown 
         <select>
          <option onpick=\"#portscan\">BACK</option>
         </select>
       </p>
      </card>
    </wml>
   ";
      } else {
       $num = (($#socks) + 1);

 print "
   <card id =\"summary\">
   <p mode=\"wrap\">
     Scan Summary 
          Connected to $num ports on $remote (scanned up to $portnum)
        <select>
          <option onpick=\"#portscan\">BACK</option>
         </select>
   </p>
   </card>
   </wml>
   ";
   }
}

sub traceroute {
my $remote = shift;
my $traceroute = $config{traceroute};

print $header;
print "<wml>";
print "
   <card title=\"Traceroute\">
    <p mode=\"wrap\">
     <select>\n";
       open(TRACE, "$traceroute $remote|") || 
          print "<option onpick=\"../../nagios/$config{wml_root}\">Error - Back</option>";
       
             while (<TRACE>) {
                chomp;
                $_ =~ (s/^\s+//g);
                $_ =~ (s/\s+/:/g);
                ($hop,$host,$ip,$m1,$m2,$m3,$m4,$m5,$m6) = (split(/:/, $_));
print "<option onpick=\"$config{ping_cgi}?$host\">$hop-->$host</option>\n";
             #   print "$ip $m1 $m2 $m3 $m4 $m5 $m6\n";
            }
  print "</select>\n";

  print "</p> </card>";
  print "</wml>";
  close TRACE;
 

}
